------------------------------------------------------------------------- 
--
-- Licensed Materials - Property of IBM
-- 5724-B99MQ
-- 
-- (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- 
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
-- 
-- File Information: MQS/MQS_TEDW/src/tedw_apps_etl/ctq/pkg/v110/cdw/ddl/ctq_cdw_schema.sql, MQS_TEDW, amsmqs_5.1.1, 200405251803
-- Revision: 1.3
-- Date: 8/20/02 14:48:53
--
-----------------------------------------------------------------------

-- CDW tables for IBM Tivoli Monitoring for Business Integration,
-- Version 5.1.0 : WebSphere MQ 
-- Owner of these tables is CTQ
-- CTQ is the unique AVA code for IBM Tivoli Monitoring for Business 
-- Integration, Version 5.1.0 : WebSphere MQ

-----------------------------------------------------------------------
-- Create staging tables for component primary key information
-----------------------------------------------------------------------

-- Staging table for WebSphere MQ queue manager component primary keys
CREATE TABLE CTQ.STAGE_QMGR_KEY (
         comp_id              INTEGER NOT NULL,
         comp_nm              VARCHAR(254) NOT NULL,
         compattr_strt_dttm   timestamp NOT NULL,
            primary key (comp_id, compattr_strt_dttm)
);


-- Staging table for WebSphere MQ queue component primary keys
CREATE TABLE CTQ.STAGE_QUEUE_KEY (
         comp_id              INTEGER NOT NULL,
         comp_nm              VARCHAR(254) NOT NULL,
         compattr_strt_dttm   timestamp NOT NULL,
            primary key (comp_id, compattr_strt_dttm)
);


-- Staging table for WebSphere MQ channel component primary keys
CREATE TABLE CTQ.STAGE_CHANNEL_KEY (
         comp_id              INTEGER NOT NULL,
         comp_nm              VARCHAR(254) NOT NULL,
         compattr_strt_dttm   timestamp NOT NULL,
            primary key (comp_id, compattr_strt_dttm)
);

                 
-----------------------------------------------------------------------
-- Create tables for metric information
-----------------------------------------------------------------------

-- Permanent table for WebSphere MQ queue manager metrics
CREATE TABLE CTQ.QMGR_METRIC (
         insert_dttm    timestamp,
         metric_id      INTEGER NOT NULL,
         met_name       VARCHAR(120) NOT NULL,
         met_desc       VARCHAR(254) NOT NULL,
         met_units      VARCHAR(120) NOT NULL,
         met_category   VARCHAR(10) NOT NULL,
         msrc_nm        VARCHAR(120) NOT NULL,
         min_exists     CHAR(1) NOT NULL,
         max_exists     CHAR(1) NOT NULL,
         avg_exists     CHAR(1) NOT NULL,
         total_exists   CHAR(1) NOT NULL,
            primary key (metric_id)
 );


-- Permanent table for WebSphere MQ queue metrics
CREATE TABLE CTQ.QUEUE_METRIC (
         insert_dttm    timestamp,
         metric_id      INTEGER NOT NULL,
         met_name       VARCHAR(120) NOT NULL,
         met_desc       VARCHAR(254) NOT NULL,
         met_units      VARCHAR(120) NOT NULL,
         met_category   VARCHAR(10) NOT NULL,
         msrc_nm        VARCHAR(120) NOT NULL,
         min_exists     CHAR(1) NOT NULL,
         max_exists     CHAR(1) NOT NULL,
         avg_exists     CHAR(1) NOT NULL,
         total_exists   CHAR(1) NOT NULL,
            primary key (metric_id)
 );


-- Permanent table for WebSphere MQ channel metrics
CREATE TABLE CTQ.CHANNEL_METRIC (
         insert_dttm    timestamp,
         metric_id      INTEGER NOT NULL,
         met_name       VARCHAR(120) NOT NULL,
         met_desc       VARCHAR(254) NOT NULL,
         met_units      VARCHAR(120) NOT NULL,
         met_category   VARCHAR(10) NOT NULL,
         msrc_nm        VARCHAR(120) NOT NULL,
         min_exists     CHAR(1) NOT NULL,
         max_exists     CHAR(1) NOT NULL,
         avg_exists     CHAR(1) NOT NULL,
         total_exists   CHAR(1) NOT NULL,
            primary key (metric_id)
 );

