------------------------------------------------------------------------ 
--
-- Licensed Materials - Property of IBM
-- 5724-B99MQ
-- 
-- (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- 
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
-- 
-- File Information: MQS/MQS_TEDW/src/tedw_apps_etl/ctq/pkg/v110/mart/ddl/ctq_mart_drop_schema.sql, MQS_TEDW, amsmqs_5.1.1, 200405251803
-- Revision: 1.2
-- Date: 8/20/02 14:49:46
--
-----------------------------------------------------------------------

-- MART drop of staging tables for IBM Tivoli Monitoring for Business 
-- Integration, Version 5.1.0 : WebSphere MQ 
-- Owner of these tables is CTQ
-- CTQ is the unique AVA code for IBM Tivoli Monitoring for Business 
-- Integration, Version 5.1.0 : WebSphere MQ

-----------------------------------------------------------------------
-- Drop metric dimension tables
-----------------------------------------------------------------------

-- Metric dimension table for WebSphere MQ queue managers  
DROP TABLE CTQ.D_QMGR_METRIC;

-- Metric dimension table for WebSphere MQ queues
DROP TABLE CTQ.D_QUEUE_METRIC;

-- Metric dimension table for WebSphere MQ channels
DROP TABLE CTQ.D_CHANNEL_METRIC;
                                                  

-----------------------------------------------------------------------
-- Drop component dimension tables 
-----------------------------------------------------------------------

-- Dimension table for WebSphere MQ hosts
DROP TABLE CTQ.D_HOST;

-- Dimension table for WebSphere MQ queue managers
DROP TABLE CTQ.D_QMGR;

-- Dimension table for WebSphere MQ queues
DROP TABLE CTQ.D_QUEUE;

-- Dimension table for WebSphere MQ channels
DROP TABLE CTQ.D_CHANNEL;


-----------------------------------------------------------------------
-- Drop WebSphere MQ queue manager fact tables 
-----------------------------------------------------------------------
         
-- Hour fact table for all metrics against WebSphere MQ queue managers
DROP TABLE CTQ.F_QMGR_HOUR;

-- Day fact table for all metrics against WebSphere MQ queue managers
DROP TABLE CTQ.F_QMGR_DAY;

-- Week fact table for all metrics against WebSphere MQ queue managers
DROP TABLE CTQ.F_QMGR_WEEK;

-- Month fact table for all metrics against WebSphere MQ queue managers
DROP TABLE CTQ.F_QMGR_MONTH;


-----------------------------------------------------------------------
-- Drop WebSphere MQ queue fact tables 
-----------------------------------------------------------------------

-- Hour fact table for all metrics against WebSphere MQ queues 
DROP TABLE CTQ.F_QUEUE_HOUR;

-- Day fact table for all metrics against WebSphere MQ queues 
DROP TABLE CTQ.F_QUEUE_DAY;

-- Week fact table for all metrics against WebSphere MQ queues 
DROP TABLE CTQ.F_QUEUE_WEEK;

-- Month fact table for all metrics against WebSphere MQ queues 
DROP TABLE CTQ.F_QUEUE_MONTH;


-----------------------------------------------------------------------
-- Drop WebSphere MQ queue fact tables 
-----------------------------------------------------------------------

-- Hour fact table for all metrics against WebSphere MQ channels
DROP TABLE CTQ.F_CHNL_HOUR;

-- Day fact table for all metrics against WebSphere MQ channels
DROP TABLE CTQ.F_CHNL_DAY;

-- Week fact table for all metrics against WebSphere MQ channels
DROP TABLE CTQ.F_CHNL_WEEK;

-- Month fact table for all metrics against WebSphere MQ channels
DROP TABLE CTQ.F_CHNL_MONTH;
                    

-----------------------------------------------------------------------
-- Drop staging tables 
-----------------------------------------------------------------------
      
-- Staging table for WebSphere MQ queue manager metrics
DROP TABLE CTQ.STAGE_D_QMGR_MET;

-- Staging table for WebSphere MQ queue metrics
DROP TABLE CTQ.STAGE_D_QUEUE_MET;

-- Staging table for WebSphere MQ channel metrics
DROP TABLE CTQ.STAGE_D_CHNL_MET;

-- Staging table for WebSphere MQ hosts
DROP TABLE CTQ.STAGE_D_HOST;

-- Staging table for WebSphere MQ queue managers
DROP TABLE CTQ.STAGE_D_QMGR;

-- Staging table for WebSphere MQ queues
DROP TABLE CTQ.STAGE_D_QUEUE;

-- Staging table for WebSphere MQ channels
DROP TABLE CTQ.STAGE_D_CHANNEL;

-- Staging hour fact table for all metrics against WebSphere MQ queue managers
DROP TABLE CTQ.STAGE_F_QMGR_HOUR;

-- Staging hour fact table for all metrics against WebSphere MQ queues 
DROP TABLE CTQ.STAGE_F_QUEUE_HOUR;

-- Staging hour fact table for all metrics against WebSphere MQ channels
DROP TABLE CTQ.STAGE_F_CHNL_HOUR;
 


-----------------------------------------------------------------------
-- Drop Prune control and log tables  
-----------------------------------------------------------------------

-- Control table for pruning obsolete data from all WebSphere MQ fact tables
DROP TABLE CTQ.PRUNE_MART_CONTROL;

-- Log table for logging the pruning of obsolete data from all WebSphere MQ fact tables
DROP TABLE CTQ.PRUNE_MART_LOG;

