------------------------------------------------------------------------- 
--
-- Licensed Materials - Property of IBM
-- 5724-B99MQ
-- 
-- (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- 
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
-- 
-- File Information: MQS/MQS_TEDW/src/tedw_apps_etl/ctq/pkg/v110/mart/dml/ctq_mart_data.sql, MQS_TEDW, amsmqs_5.1.1, 200405251803
-- Revision: 1.3
-- Date: 8/20/02 14:49:55
--
-----------------------------------------------------------------------

-----------------------------------------------------------------------
-- Insert data into control table for pruning obsolete data from all 
-- IBM Tivoli Monitoring for Business Integration, Version 5.1.0 : WebSphere 
-- MQ fact tables.
-- A date duration is decimal(8,0) and has the format yyyymmdd.
-----------------------------------------------------------------------

-- create temporary table for prune mart control
DECLARE global temporary TABLE Prune_Mart_Control(
       Table_Name           VARCHAR(120) NOT NULL,
       PMartC_Duration      DECIMAL(8,0) NOT NULL
) 
WITH REPLACE ON COMMIT preserve ROWS NOT logged
;

INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QMGR_HOUR', 00000300);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QMGR_DAY', 00000300);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QMGR_WEEK', 00010000);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QMGR_MONTH', 00010000);

INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QUEUE_HOUR', 00000300);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QUEUE_DAY', 00000300);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QUEUE_WEEK', 00010000);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_QUEUE_MONTH', 00010000);

INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_CHNL_HOUR', 00000300);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_CHNL_DAY', 00000300);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_CHNL_WEEK', 00010000);
INSERT INTO session.Prune_Mart_Control VALUES ('CTQ.F_CHNL_MONTH', 00010000);

INSERT INTO CTQ.Prune_Mart_Control (Table_Name, PMartC_Duration)
SELECT 
   s.Table_Name,
   s.PMartC_Duration
FROM 
   session.Prune_Mart_Control s
WHERE NOT EXISTS
( 
  SELECT 1 FROM
  CTQ.Prune_Mart_Control t
  WHERE
  t.Table_Name = s.Table_Name 
);

-----------------------------------------------------------------------
-- Drop temporary session tables 
-----------------------------------------------------------------------

-- drop temporary table for prune mart control
DROP TABLE session.Prune_Mart_Control;
