------------------------------------------------------------------------- 
--
-- Licensed Materials - Property of IBM
-- 5724-B99MQ
-- 
-- (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- 
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
-- 
-- File Information: MQS/MQS_TEDW/src/tedw_apps_etl/ctq/pkg/v110/etl/sql/ctq_m15_s010_fact.db2, MQS_TEDW, amsmqs
-- Revision: 1.4
-- Date: 7/16/02 12:42:43
--
-----------------------------------------------------------------------

--#VERSION 1.1.0.1.0

----------------------------------------------------------------------
-- Prune obsolete data from all fact tables based on the value in the 
-- PMartC_Duration column for the associated table.
-----------------------------------------------------------------------

--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue manager hour fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QMGR_HOUR',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QMGR_HOUR'),
  (select count(*) from CTQ.F_QMGR_HOUR f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QMGR_HOUR')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from Websphere MQ queue manager hour fact table
DELETE FROM CTQ.F_QMGR_HOUR f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QMGR_HOUR')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue manager day fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QMGR_DAY',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QMGR_DAY'),
  (select count(*) from CTQ.F_QMGR_DAY f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QMGR_DAY')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ queue manager day fact table
DELETE FROM CTQ.F_QMGR_DAY f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QMGR_DAY')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue manager week fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QMGR_WEEK',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QMGR_WEEK'),
  (select count(*) from CTQ.F_QMGR_WEEK f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QMGR_WEEK')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ queue manager week fact table
DELETE FROM CTQ.F_QMGR_WEEK f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QMGR_WEEK')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue manager month fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QMGR_MONTH',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QMGR_MONTH'),
  (select count(*) from CTQ.F_QMGR_MONTH f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QMGR_MONTH')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ queue manager month fact table
DELETE FROM CTQ.F_QMGR_MONTH f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QMGR_MONTH')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue hour fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QUEUE_HOUR',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QUEUE_HOUR'),
  (select count(*) from CTQ.F_QUEUE_HOUR f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QUEUE_HOUR')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ queue hour fact table
DELETE FROM CTQ.F_QUEUE_HOUR f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QUEUE_HOUR')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue day fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QUEUE_DAY',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QUEUE_DAY'),
  (select count(*) from CTQ.F_QUEUE_DAY f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QUEUE_DAY')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ queue day fact table
DELETE FROM CTQ.F_QUEUE_DAY f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QUEUE_DAY')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue week fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QUEUE_WEEK',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QUEUE_WEEK'),
  (select count(*) from CTQ.F_QUEUE_WEEK f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QUEUE_WEEK')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ queue week fact table
DELETE FROM CTQ.F_QUEUE_WEEK f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QUEUE_WEEK')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ queue month fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_QUEUE_MONTH',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_QUEUE_MONTH'),
  (select count(*) from CTQ.F_QUEUE_MONTH f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_QUEUE_MONTH')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ queue month fact table
DELETE FROM CTQ.F_QUEUE_MONTH f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_QUEUE_MONTH')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ channel hour fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_CHNL_HOUR',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_CHNL_HOUR'),
  (select count(*) from CTQ.F_CHNL_HOUR f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_CHNL_HOUR')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ channel hour fact table
DELETE FROM CTQ.F_CHNL_HOUR f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_hour)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_CHNL_HOUR')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ channel day fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_CHNL_DAY',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_CHNL_DAY'),
  (select count(*) from CTQ.F_CHNL_DAY f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_CHNL_DAY')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ channel day fact table
DELETE FROM CTQ.F_CHNL_DAY f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_CHNL_DAY')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ channel week fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_CHNL_WEEK',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_CHNL_WEEK'),
  (select count(*) from CTQ.F_CHNL_WEEK f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_CHNL_WEEK')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ channel week fact table
DELETE FROM CTQ.F_CHNL_WEEK f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_CHNL_WEEK')
;


--#EXECUTE_AT_TARGET
-- log the pruning from Websphere MQ channel month fact table
insert into CTQ.Prune_Mart_Log (PMart_Run_DtTM, Table_Name, PMartC_Duration, Number_Pruned) values ( 
  current timestamp - current timezone,  
  'CTQ.F_CHNL_MONTH',
  (select PMartC_Duration from CTQ.Prune_Mart_Control 
     where Table_Name='CTQ.F_CHNL_MONTH'),
  (select count(*) from CTQ.F_CHNL_MONTH f  
     where (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
        (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
        WHERE p.Table_Name= 'CTQ.F_CHNL_MONTH')
  )      
)
;  


--#EXECUTE_AT_TARGET
-- Prune data from WebSphere MQ channel month fact table
DELETE FROM CTQ.F_CHNL_MONTH f
WHERE
   (DATE(CURRENT timestamp - CURRENT timezone) - DATE(f.meas_date)) > 
    (SELECT PMartC_Duration FROM CTQ.Prune_Mart_Control p
     WHERE p.Table_Name = 'CTQ.F_CHNL_MONTH')
;


--#EXECUTE_AT_TARGET
-- Delete entries in Prune Control Log indicating no data was pruned
delete from CTQ.Prune_Mart_Log 
where
    Number_Pruned = 0
;

-----------------------------------------------------------------------
-- insert WebSphere MQ queue manager measurements 
-----------------------------------------------------------------------

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table CTQ.STAGE_F_QMGR_HOUR;

--#EXECUTE_AT_TARGET
create table CTQ.STAGE_F_QMGR_HOUR (
         qmgr_id            INTEGER NOT NULL,
         XQ_qmgr_state_dttm timestamp NOT NULL, 
         host_id            INTEGER NOT NULL,
         metric_id          INTEGER NOT NULL,
         meas_hour          timestamp NOT NULL,
         min_value          FLOAT,
         max_value          FLOAT,
         avg_value          FLOAT,
         total_value        FLOAT,
         sample_count       INTEGER,
               primary key (qmgr_id, XQ_qmgr_state_dttm, host_id, metric_id, meas_hour)
);


-- set the high value for the window
update TWG.Extract_Control set 
    extctl_to_intseq =  (select max(msmt_id) from TWG.MSMT)
where 
    extctl_source='TWG.MSMT' and
    extctl_target='CTQ.F_QMGR_HOUR' and
    (select count(*) from TWG.MSMT ) > 0  
;


--#INSERT_INTO_TARGET
-- insert WebSphere MQ queue manager measurements into staging table 
insert into CTQ.STAGE_F_QMGR_HOUR (qmgr_id, XQ_qmgr_state_dttm, host_id, metric_id, meas_hour,
                                   min_value, max_value, avg_value, total_value, sample_count)
select 
    m.comp_id,   
    max(ca.compattr_strt_dttm),
    r.comp_source_id, 
    m.msmttyp_id, 
    timestamp(m.msmt_strt_dt,m.msmt_strt_tm), 
    avg(m.msmt_min_val), 
    avg(m.msmt_max_val), 
    avg(m.msmt_avg_val), 
    avg(m.msmt_tot_val),
    avg(m.msmt_smpl_cnt)
from  
    TWG.Msmt m,
    TWG.Cur_Comp c,
    TWG.Cur_CompAttr ca,
    TWG.Cur_CompReln r,
    TWG.Extract_control ec
where  
    ec.extctl_source = 'TWG.MSMT' and
    ec.extctl_target = 'CTQ.F_QMGR_HOUR' and
    m.msmt_id > ec.extctl_from_intseq and
    m.msmt_id <= ec.extctl_to_intseq and
    m.tmsum_cd = 'H' and
    c.comp_id = m.comp_id and
    c.comptyp_cd = 'CTQ_QMGR' and
    ca.comp_id = c.comp_id and
    ca.attrtyp_cd in ('CTQ_QMGRPLATFORM', 'CTQ_QMGRCMDLVL') and
    r.comp_target_id = c.comp_id and
    r.relntyp_cd= 'PCHILD'
group by
    m.comp_id, r.comp_source_id, m.msmttyp_id, m.msmt_strt_dt, m.msmt_strt_tm
;


--#EXECUTE_AT_TARGET
-- copy WebSphere MQ queue measurements from staging table into hour fact table 
insert into CTQ.F_QMGR_HOUR (qmgr_id, XQ_qmgr_state_dttm, host_id, metric_id, meas_hour,
                             min_value, max_value, avg_value, total_value, sample_count)
select 
    s.qmgr_id,   
    s.XQ_qmgr_state_dttm,
    s.host_id, 
    s.metric_id, 
    s.meas_hour, 
    s.min_value, 
    s.max_value, 
    s.avg_value, 
    s.total_value,
    s.sample_count
from 
    CTQ.STAGE_F_QMGR_HOUR s
;

                      
-- confirm insertion of data by inserting a row into TWG.EXTRACT_LOG.
insert into twg.extract_log (extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq,
                             extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm,
                             extlog_to_dttm)
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - current timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.MSMT' and
 ec.extctl_target = 'CTQ.F_QMGR_HOUR'
; 

                                           

-----------------------------------------------------------------------
-- insert WebSphere MQ queue measurements
-----------------------------------------------------------------------

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table CTQ.STAGE_F_QUEUE_HOUR;

--#EXECUTE_AT_TARGET
create table CTQ.STAGE_F_QUEUE_HOUR (
         queue_id           INTEGER NOT NULL,
         XQ_queu_state_dttm timestamp NOT NULL,
         qmgr_id            INTEGER NOT NULL,
         XQ_qmgr_state_dttm timestamp NOT NULL,
         host_id            INTEGER NOT NULL,
         metric_id          INTEGER NOT NULL,
         meas_hour          timestamp NOT NULL,
         min_value          FLOAT,
         max_value          FLOAT,
         avg_value          FLOAT,
         total_value        FLOAT,
         sample_count       INTEGER,
               primary key (queue_id, XQ_queu_state_dttm, qmgr_id, XQ_qmgr_state_dttm,
                            host_id, metric_id, meas_hour)
);


-- set the high value for the window
update TWG.Extract_Control set 
    extctl_to_intseq =  ( select max(msmt_id) from TWG.MSMT)
where 
    extctl_source='TWG.MSMT' and
    extctl_target='CTQ.F_QUEUE_HOUR' and
    (select count(*) from TWG.MSMT ) > 0  
;


--#INSERT_INTO_TARGET
-- copy WebSphere MQ queue measurements into staging table                        
insert into CTQ.STAGE_F_QUEUE_HOUR (queue_id, XQ_queu_state_dttm, qmgr_id, XQ_qmgr_state_dttm, host_id,
                                    metric_id, meas_hour, min_value, max_value, avg_value, total_value,
                                    sample_count)
select 
    m.comp_id,
    max(ca1.compattr_strt_dttm),
    r1.comp_source_id,
    max(ca2.compattr_strt_dttm),
    r2.comp_source_id, 
    m.msmttyp_id, 
    timestamp(m.msmt_strt_dt,m.msmt_strt_tm), 
    avg(m.msmt_min_val), 
    avg(m.msmt_max_val), 
    avg(m.msmt_avg_val), 
    avg(m.msmt_tot_val),
    avg(m.msmt_smpl_cnt) 
from  
    TWG.Msmt m,
    TWG.Cur_Comp c,
    TWG.Cur_CompAttr ca1,
    TWG.Cur_CompAttr ca2,
    TWG.Cur_CompReln r1,
    TWG.Cur_CompReln r2,
    TWG.Extract_control ec
where  
    ec.extctl_source = 'TWG.MSMT' and
    ec.extctl_target = 'CTQ.F_QUEUE_HOUR' and
    m.msmt_id > ec.extctl_from_intseq and
    m.msmt_id <= ec.extctl_to_intseq and
    m.tmsum_cd = 'H' and
    c.comp_id = m.comp_id and
    c.comptyp_cd = 'CTQ_QUEUE' and
    ca1.comp_id = c.comp_id and
    ca1.attrtyp_cd in ('CTQ_QUEUETYPE', 'CTQ_QUEUEUSAGE') and
    r1.comp_target_id = c.comp_id and
    r1.relntyp_cd= 'PCHILD' and
    ca2.comp_id = r1.comp_source_id and
    ca2.attrtyp_cd in ('CTQ_QMGRPLATFORM', 'CTQ_QMGRCMDLVL') and
    r1.comp_source_id = r2.comp_target_id and
    r1.relntyp_cd = 'PCHILD'
group by
    m.comp_id, r1.comp_source_id, r2.comp_source_id, m.msmttyp_id, m.msmt_strt_dt, 
    m.msmt_strt_tm
;


--#EXECUTE_AT_TARGET
-- Copy WebSphere MQ queue measurements from staging table into hour fact table
insert into CTQ.F_QUEUE_HOUR (queue_id, XQ_queu_state_dttm, qmgr_id, XQ_qmgr_state_dttm, host_id,
                              metric_id, meas_hour, min_value, max_value, avg_value, total_value,
                              sample_count)
select 
    s.queue_id,
    s.XQ_queu_state_dttm,
    s.qmgr_id,
    s.XQ_qmgr_state_dttm,
    s.host_id, 
    s.metric_id, 
    s.meas_hour, 
    s.min_value, 
    s.max_value, 
    s.avg_value, 
    s.total_value,
    s.sample_count
from 
    CTQ.STAGE_F_QUEUE_HOUR s
;


-- confirm insertion of data by inserting a row into TWG.EXTRACT_LOG.
insert into twg.extract_log (extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq,
                             extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm,
                             extlog_to_dttm)
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - current timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.MSMT' and
 ec.extctl_target = 'CTQ.F_QUEUE_HOUR'
;
 

-----------------------------------------------------------------------
-- insert WebSphere MQ channel measurements
-----------------------------------------------------------------------

--#IGNORE_ERROR
--#EXECUTE_AT_TARGET
drop table CTQ.STAGE_F_CHNL_HOUR;

--#EXECUTE_AT_TARGET
create table CTQ.STAGE_F_CHNL_HOUR (
         channel_id         INTEGER NOT NULL,
         XQ_chnl_state_dttm timestamp NOT NULL,
         qmgr_id            INTEGER NOT NULL,
         XQ_qmgr_state_dttm timestamp NOT NULL,
         host_id            INTEGER NOT NULL,
         metric_id          INTEGER NOT NULL,
         meas_hour          timestamp NOT NULL,
         min_value          FLOAT,
         max_value          FLOAT,
         avg_value          FLOAT,
         total_value        FLOAT,
         sample_count       INTEGER,
               primary key (channel_id, XQ_chnl_state_dttm, qmgr_id, XQ_qmgr_state_dttm,
                            host_id, metric_id, meas_hour)
);

-- set the high value for the window
update TWG.Extract_Control set 
    extctl_to_intseq =  ( select max(msmt_id) from TWG.MSMT)
where 
    extctl_source='TWG.MSMT' and
    extctl_target='CTQ.F_CHNL_HOUR' and
    (select count(*) from TWG.MSMT ) > 0  
;


--#INSERT_INTO_TARGET
-- insert WebSphere MQ channel measurements into staging table
insert into CTQ.STAGE_F_CHNL_HOUR (channel_id, XQ_chnl_state_dttm, qmgr_id, XQ_qmgr_state_dttm,
                                   host_id, metric_id, meas_hour, min_value, max_value, avg_value,
                                   total_value, sample_count)  
select 
    m.comp_id,
    max(ca1.compattr_strt_dttm),
    r1.comp_source_id,
    max(ca2.compattr_strt_dttm),
    r2.comp_source_id, 
    m.msmttyp_id, 
    timestamp(m.msmt_strt_dt,m.msmt_strt_tm), 
    avg(m.msmt_min_val), 
    avg(m.msmt_max_val), 
    avg(m.msmt_avg_val), 
    avg(m.msmt_tot_val),
    avg(m.msmt_smpl_cnt) 
from  
    TWG.Msmt m,
    TWG.Cur_Comp c,
    TWG.Cur_CompAttr ca1,
    TWG.Cur_CompAttr ca2,
    TWG.Cur_CompReln r1,
    TWG.Cur_CompReln r2,
    TWG.Extract_control ec
where  
    ec.extctl_source = 'TWG.MSMT' and
    ec.extctl_target = 'CTQ.F_CHNL_HOUR' and
    m.msmt_id > ec.extctl_from_intseq and
    m.msmt_id <= ec.extctl_to_intseq and
    m.tmsum_cd = 'H' and
    c.comp_id = m.comp_id and
    c.comptyp_cd = 'CTQ_CHANNEL' and
    ca1.comp_id = c.comp_id and
    ca1.attrtyp_cd in ('CTQ_CHANNELTYPE', 'CTQ_CHANNELPROT', 'CTQ_CHANNELTRANS') and
    r1.comp_target_id = c.comp_id and
    r1.relntyp_cd= 'PCHILD' and
    ca2.comp_id = r1.comp_source_id and
    ca2.attrtyp_cd in ('CTQ_QMGRPLATFORM', 'CTQ_QMGRCMDLVL') and
    r1.comp_source_id = r2.comp_target_id and
    r1.relntyp_cd = 'PCHILD'
group by
    m.comp_id, r1.comp_source_id, r2.comp_source_id,  m.msmttyp_id, m.msmt_strt_dt, 
    m.msmt_strt_tm
;


--#EXECUTE_AT_TARGET
-- Copy WebSphere MQ channel measurements from staging table into hour fact table
insert into CTQ.F_CHNL_HOUR (channel_id, XQ_chnl_state_dttm, qmgr_id, XQ_qmgr_state_dttm,
                             host_id, metric_id, meas_hour, min_value, max_value, avg_value,
                             total_value, sample_count)
select 
    s.channel_id,
    s.XQ_chnl_state_dttm,
    s.qmgr_id,
    s.XQ_qmgr_state_dttm,
    s.host_id, 
    s.metric_id, 
    s.meas_hour, 
    s.min_value, 
    s.max_value, 
    s.avg_value, 
    s.total_value,
    s.sample_count 
from 
    CTQ.STAGE_F_CHNL_HOUR s
;


-- confirm insertion of data by inserting a row into TWG.EXTRACT_LOG.
insert into twg.extract_log (extlog_source, extlog_target, extlog_done_dttm, extlog_from_rawseq,
                             extlog_to_rawseq, extlog_from_intseq, extlog_to_intseq, extlog_from_dttm,
                             extlog_to_dttm)
select
 ec.extctl_source,
 ec.extctl_target,
 current timestamp - current timezone,
 ec.extctl_from_rawseq,
 ec.extctl_to_rawseq,
 ec.extctl_from_intseq,
 ec.extctl_to_intseq,
 ec.extctl_from_dttm,
 ec.extctl_to_dttm
from 
 TWG.Extract_control ec
where
 ec.extctl_source = 'TWG.MSMT' and
 ec.extctl_target = 'CTQ.F_CHNL_HOUR'
; 
      
